Subject: [PATCH] serial: 8250: Make ISA ports optional

From: [email-masked] (Peter Hurley)
Date: Tue, 06 Jan 2015 16:47:55 -0500

On 01/06/2015 02:43 PM, Arnd Bergmann wrote:
> On Tuesday 06 January 2015 09:32:02 Peter Hurley wrote:
>> On 01/06/2015 08:13 AM, Arnd Bergmann wrote:
>>> On Monday 05 January 2015 22:09:45 Peter Hurley wrote:
>>>> Some arches have no need to create unprobed 8250 ports; these phantom
>>>> ports are primarily required for ISA ports which have no probe
>>>> mechanism or to provide non-operational ports for userspace to
>>>> configure (via TIOCSSERIAL and TIOCSERCONFIG ioctls).
>>>>
>>>> Provide CONFIG_SERIAL_8250_PHANTOM_UARTS knob to disable phantom port
>>>> registration; ie., CONFIG_SERIAL_8250_PHANTOM_UARTS=N only registers
>>>> probed ports (ACPI/PNP, "serial8250" platform devices, PCI, etc).
>>>>
>>>> Cc: Sebastian Andrzej Siewior <[email-masked]>
>>>> Cc: Tony Lindgren <[email-masked]>
>>>> Cc: Grant Likely <[email-masked]>
>>>> Cc: Arnd Bergmann <[email-masked]>
>>>> Signed-off-by: Peter Hurley <[email-masked]>
>>>
>>> The intent is definitely right, but I think a better approach is
>>> possible.
>>>
>>> I haven't tried it here, but how about moving the serial8250_init
>>> function into a separate module, along with all the other parts
>>> that are only used for ISA devices, but leaving the actual core
>>> (all exported symbols) in this file?
>>
>> Unfortunately, I don't see a way to remove the stacked initialization
>> without risking tons of breakage.
>>
>> Since later probes can "find" an already-existing port and
>> re-initialize it, the probe order is crucial. For example, a PCI
>> probe can "find" an existing "serial8250" platform device port,
>> resulting in only one device node.
> 
> I'm probably missing something important, by why would that
> be any different if the PCI driver gets loaded first and the
> ISA driver second?

Well, the PCI driver would have the proper irq, for one. So, if the
the platform driver re-initialized the port to the wrong irq...

>> And the configuration knob will be required on all arches anyway because
>> that's how user-configurable device nodes are created.
> 
> I think that's fine: The user-configurable ports are the same as
> the "ISA" or "phantom" ports we were talking about above, right?

Yes.

> If those are part of a separate (possibly loadable) module, having
> a configuration knob is the obvious way to do it. A lot of architectures
> can just turn it off because they know exactly which ports are present
> and there is no need for user-configurability. The ones that don't know
> can load the module.

Let me give this some more thought.

Regards,
Peter Hurley